/************************************************************************************/
/*																					*/
/*				echo - Display diagnostic/informative messages						*/
/*																					*/
/*				Philip Rakity									8/27/87				*/
/*																					*/
/*			 Copyright  1987-88, Apple Computer, Inc.  All rights reserved.		*/
/*																					*/
/************************************************************************************/

#include	"os.h"
#include	"managers.h"

#define	PREVERROR(xx)	((xx) & 0x8000)
#define	TRUE			1

	pascal void illegal ()
		extern	0x4afc;
	
static	char		my_object_name [] = "echo example";
static	char		my_type_name []   = "echo manager";

/*
 *	echo_example - main task loop.
 */
void echo_example()
{
	tid_type		tid;
	message			*m;
		
	if (!Register_Task (my_object_name, my_type_name, Machine_Visible))
		illegal ();
			
	while(TRUE)
	{
		m = Receive( OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, OS_NO_TIMEOUT );	
		
		/* check if we are receiving a message whose code has been set to be unknown	*/
		/* if we are, release the message.  This is needed to avoid loops.  The buffer	*/
		/* if any is not released, since it might be shared between processes.			*/
		
		if (PREVERROR (m -> mCode))
		{
			FreeMsg (m);
		}
		else
		{
			m -> mCode += 1;
			tid = m -> mFrom;
			m -> mFrom = m -> mTo;
			m -> mTo = tid;
			Send (m);
		}
	}
}