/****************************************************************************************/
/*																						*/
/*						name_tester - A/ROSE name test task.							*/
/*																						*/
/*																						*/
/*					Richard W. Mincher.						05/01/87.					*/
/*					Philip Rakity							08/20/87					*/
/*					Anumele D. Raja							03/27/91					*/
/*						Removed all references to IMM									*/
/*																						*/
/*				Copyright  1987-91, Apple Computer, Inc.  All rights reserved.			*/
/*																						*/
/****************************************************************************************/

#include "os.h"
#include "arose.h"
#include "managers.h"

pascal	void	illegal ()
		extern	0x4afc;

static	char	tester_name [] = "tester program";
static	short	test_number;
static	message	*msgptr;

#define TRUE	1
#define	FALSE	0
tester ()
{
	short						i;
	tid_type					name_server_tid;
	tid_type					my_tid;
	tid_type					temptid;
	struct	pb_lookup_tid		*ltid_ptr;
	struct	pb_lookup_name		*lnam_ptr;
	struct	pb_unregister_name	*lunr_ptr;
	struct ra_GetCards			get_cards;
	char						*memptr;
	unsigned long				mId;
	register struct mMessage	*p;
	tid_type					tid;
	struct gCommon				*gptr;
	unsigned short				index;
	void						delay ();
	
	test_number = 0;
	
	while ( GetNameTID() == 0)
		delay (3);
		
	name_server_tid = GetNameTID ();
	my_tid = GetTID ();

#ifdef PRINT		
	printf("TID = %x - tester task starting.\n", GetTID ());
	printf ("TID = %x - tester task heap addr = %x\n", GetTID (), GetHeap());
#endif	

	while (1)	
	{
		
		/* register task test						*/
		
		if (!Register_Task ("tester", "pmr", Locally_Visible))	
			illegal ();
		
		/* lookup process id test					*/
		
		test_number++;
	
		index = 0;
		if((tid = Lookup_Task ("tester", "pmr", name_server_tid, &index)) != my_tid)
			illegal();
		
			
	/*	Check bad sends	*/
	
		test_number++;
	
		for (i = 0; i < 16; ++i)			
		{
			delay (GetTickPS ());
			p = GetMsg();
			if (p == 0)
				illegal ();
			if ((ltid_ptr = (struct pb_lookup_tid *) 
					GetMem (1000 + sizeof(struct pb_lookup_tid))) == NULL)
				illegal ();
			p->mTo = i*256 + 100;	/*	Bad tid	*/
			p->mCode = NM_LOOKUP_TID;
			p->mDataPtr = (char *)ltid_ptr;
			p->mDataSize = 1000 + sizeof(struct pb_lookup_tid);
			p->mStatus = 0;
			ltid_ptr->ltid_index = 0;
			mId = p->mId;
			printf("TID = %x - About to send msg = %X, ID = %08X\n", GetTID (), p, p->mId);
			printf("TID = %x - To: %04X, mCode = %d, mDataSize = %d\n", GetTID (), p->mTo,
				p->mCode, p->mDataSize);
			Send(p);
			printf("TID = %x - Sent message, waiting for reply ----\n", GetTID ());
			p = Receive(mId, OS_MATCH_ALL, OS_MATCH_ALL,  
					OS_NO_TIMEOUT);
			printf("TID = %x - Received msg = %X, ID = %08X\n", GetTID (), p, p->mId);
			printf("TID = %x - From: %04X, To: %04X, mCode = %d, mStatus = %d\n", GetTID (),
				p->mFrom, p->mTo, p->mCode, p->mStatus);
			FreeMem(p -> mDataPtr);
			FreeMsg(p);
		}
	
#ifdef PRINT	
		printf ("TID = %x - Task tester - tid = %x\n", GetTID (), tid);
#endif PRINT
	
		/* lookup name test							*/
		
		test_number++;
	
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = NM_LOOKUP_NAME;
	
		if ((lnam_ptr = (struct pb_lookup_name *) 
				GetMem (513)) == NULL)
			illegal ();
			
		msgptr -> mDataPtr = (char *) lnam_ptr;
		msgptr -> mDataSize = 513;
		msgptr -> mTo = name_server_tid;
		
		lnam_ptr -> lnm_index = 0;
		lnam_ptr -> lnm_tid = my_tid;
		lnam_ptr -> lnm_RAsize = 513 - (sizeof (struct pb_lookup_name)
												- sizeof (struct ra_lnm));
												
		Send (msgptr);
	
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT);
		
#ifdef PRINT
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
#endif				
				
		FreeMem (msgptr -> mDataPtr);
		FreeMsg (msgptr);
		
	
		/* unregister name test							*/
		
		test_number++;
	
		/* Register two other names to have things to more things to unregister */
		
		if (!Register_Task ("Name1", "pmr", Locally_Visible))	
			illegal ();
		
		if (!Register_Task ("Name2", "pmr", Locally_Visible))	
			illegal ();
		
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = NM_LOOKUP_NAME;	
	
		if ((lnam_ptr = (struct pb_lookup_name *) 
				GetMem (513)) == NULL)
			illegal ();
			
		msgptr -> mDataPtr = (char *) lnam_ptr;
		msgptr -> mDataSize = 513;
		msgptr -> mTo = name_server_tid;
		
		lnam_ptr -> lnm_index = 0;
		lnam_ptr -> lnm_tid = my_tid;
		lnam_ptr -> lnm_RAsize = 513 - (sizeof (struct pb_lookup_name)
												- sizeof (struct ra_lnm));
												
		Send (msgptr);
	
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT);
		
#ifdef PRINT
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_tn.t_name);
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [2].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [2].ra_tn.t_name);
#endif				

		if ((lunr_ptr = (struct pb_unregister_name *) 
			GetMem (sizeof (struct pb_unregister_name))) == NULL)
				illegal ();
		if ((p = GetMsg ()) == NULL)
			illegal ();
		
		p -> mCode = NM_UNREG_NAME;
		p -> mDataPtr = (char *)  lunr_ptr;
		p -> mDataSize = sizeof (struct pb_unregister_name);
		p -> mTo = name_server_tid;
		lunr_ptr -> ut_on = ((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_on;
		lunr_ptr -> ut_tn = ((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_tn;
		Send(p);
		
		p = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_UNREG_NAME+1, OS_NO_TIMEOUT);
		
#ifdef PRINT
		printf ("TID = %x - object name = \"%s\", type name = \"%s\", status = %x\n", GetTID (),
				((struct pb_unregister_name *) (p -> mDataPtr)) -> ut_on.o_name,
				((struct pb_unregister_name *) (p -> mDataPtr)) -> ut_tn.t_name,
				p -> mStatus);
#endif				
		
		msgptr -> mTo = name_server_tid;
		msgptr -> mFrom = my_tid;
		msgptr -> mCode = NM_LOOKUP_NAME;	
		lnam_ptr -> lnm_index = 0;
		lnam_ptr -> lnm_tid = my_tid;
		lnam_ptr -> lnm_RAsize = 513 - (sizeof (struct pb_lookup_name)
												- sizeof (struct ra_lnm));
												
		Send (msgptr);
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1, OS_NO_TIMEOUT);
		
#ifdef PRINT
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [0].ra_tn.t_name);
		printf ("TID = %x - object name = \"%s\", type name = \"%s\"\n", GetTID (),
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_on.o_name,
				((struct pb_lookup_name *) (msgptr -> mDataPtr)) -> lnm_ra [1].ra_tn.t_name);
#endif				

		index = 0;
		if (temptid = Lookup_Task ("Name1", "pmr", GetNameTID(), &index))
		{
			printf("TID = %x - TID found for 'Name1', 'pmr' but should not be\n", GetTID());
			illegal ();
		}
		else
		{
			printf("TID = %x - name 'Name1', 'pmr' has been successfully removed.\n", GetTID());
		}
		
		FreeMem (msgptr -> mDataPtr);
		FreeMsg (msgptr);
		FreeMem (p -> mDataPtr);
		FreeMsg (p);

		/* unregister task  test								*/
	
		test_number++;
		
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = NM_UNREG_TASK;
		msgptr -> mTo = name_server_tid;
		
		Send (msgptr);
	
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_UNREG_TASK+1, OS_NO_TIMEOUT);
		FreeMsg (msgptr);
		
		/* lookup name test								*/
		
		test_number++;
	
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = NM_LOOKUP_NAME;
	
		if ((lnam_ptr = (struct pb_lookup_name *) 
				GetMem (513)) == NULL)
			illegal ();
			
		msgptr -> mDataPtr = (char *) lnam_ptr;
		msgptr -> mDataSize = 513;
		msgptr -> mTo = name_server_tid;
		
		lnam_ptr -> lnm_index = 0;
		lnam_ptr -> lnm_tid = my_tid;
		lnam_ptr -> lnm_RAsize = 513 - (sizeof (struct pb_lookup_name)
												- sizeof (struct ra_lnm));
												
		Send (msgptr);
		test_number++;
	
		msgptr = Receive( 0x100, 0x101, 0x102, 0x60 );
		if (msgptr != 0)
			illegal ();
			
		msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, NM_LOOKUP_NAME+1,  OS_NO_TIMEOUT);
		FreeMem (msgptr -> mDataPtr);
		FreeMsg (msgptr);
	
		if (GetICCTID () != 0)
		{
			if ((msgptr = GetMsg ()) == NULL)
				illegal ();
		
			msgptr -> mCode = ICC_GETCARDS;
			msgptr -> mDataPtr = (char *) &get_cards;
			msgptr -> mDataSize = sizeof (struct ra_GetCards);
			msgptr -> mTo = GetICCTID ();
			Send (msgptr);
			
			msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, ICC_GETCARDS+1,  OS_NO_TIMEOUT);
					
#ifdef	PRINT
			if (msgptr -> mStatus == 0)
			{	
				if (!Register_Task ("tester", "pmr", Machine_Visible))
					illegal ();
				
				for (i = 0; i < 16; i++)
				{
				
					/* we want to be notified if any slot has a change in communications */
					
					p = GetMsg ();
					if (p == 0)
						illegal ();
					else
					{
						p -> mTo = name_server_tid;
						p -> mCode = NM_N_SLOT_REQ;
						p -> mOData[0] = i;
						mId = p -> mId;
						Send (p);
						p = Receive (mId, OS_MATCH_ALL, OS_MATCH_ALL, OS_NO_TIMEOUT);
						printf("TID = %x - Received msg = %X, ID = %08X\n", GetTID (), p, p->mId);
					/*	delay (GetTickPS ());	*/
						printf("TID = %x - From: %04X, To: %04X, mCode = %d, mStatus = %d\n", GetTID (),
							p->mFrom, p->mTo, p->mCode, p->mStatus);
					/*	delay (GetTickPS ());	*/
						printf("TID = %x - mOData[0] = %x\n", GetTID (), p->mOData[0]);
						FreeMsg (p);
					}
				
					if (get_cards.tid [i] > 0)
					{
						printf("TID = %x - Tester Task - Entry %x - TID Found %x\n", GetTID (),
										i, get_cards.tid [i]);
						index = 0;
						while ((tid = Lookup_Task ("=", "=", get_cards.tid [i], &index)))
						{
							printf ("TID = %x - TID FOUND, tid = %x\n", GetTID (), tid);
							
							/* we want to be notified about any task found should that task stop */
							/* we will check later to see what notifications we get */
							
							p = GetMsg ();
							if (p == 0)
								illegal ();
							
							else
							{
								p -> mTo = get_cards.tid [i];
								p -> mCode = NM_N_TASK_REQ;
								p -> mOData[0] = tid;
								mId = p->mId;
								Send (p);
								p = Receive (mId, OS_MATCH_ALL, OS_MATCH_ALL, OS_NO_TIMEOUT);
								printf("TID = %x - Received msg = %X, ID = %08X\n", 
									GetTID (), p, p->mId);
							/*	delay (GetTickPS ());	*/
								printf(
									"TID = %x - From: %04X, To: %04X, mCode = %d, mStatus = %d\n", 
									GetTID (), p->mFrom, p->mTo, p->mCode, p->mStatus);
							/*	delay (GetTickPS ());	*/
								printf("TID = %x - mOData[0] = %x\n", GetTID (), p->mOData[0]);
								FreeMsg (p);
							}
						}	
					}
				}
			}
			else
				printf ("TID = %x - Tester Task - ICCM message bad status %x \n", GetTID (), 
											msgptr -> mStatus);
#endif
			FreeMsg (msgptr);
		}
		else
		{
			printf ("TID = %x - GetICCTID Failed\n", GetTID ());
/*
			illegal ();
*/
		}
	
		if ((memptr = GetMem (-513)) == NULL)
			illegal ();
			
		FreeMem (memptr);
		
#ifdef	PRINT
		printf ("TID = %x - Tester task - gCommon = %x\n", GetTID (), gptr = GetgCommon ());
		printf ("TID = %x - Tester task = TicksPerSec = %d\n", GetTID (), GetTickPS());
#endif
	
		
		/* receive any remaining messages	*/
		
		test_number++;
	
		while((msgptr = Receive (OS_MATCH_ALL, OS_MATCH_ALL, OS_MATCH_ALL, 5 * GetTickPS ())) != 0)
		{
		/*	delay (GetTickPS ());	*/
			printf("TID = %x - Received msg = %X, ID = %08X\n", GetTID (), msgptr, msgptr->mId);
		/*	delay (GetTickPS ());	*/
			printf("TID = %x - From: %04X, To: %04X, mCode = %d, mStatus = %d\n", GetTID (),
				msgptr->mFrom, msgptr->mTo, msgptr->mCode, msgptr->mStatus);
		/*	delay (GetTickPS ());	*/
			printf("TID = %x - mOData[0] = %x\n", GetTID (), msgptr->mOData[0]);
			FreeMsg (msgptr);
		}
					
#ifdef	PRINT
		printf("TID = %x - Tester task going away.\n", GetTID ());
#endif

		/* unregister task  test								*/
	
		test_number++;
		
		if ((msgptr = GetMsg ()) == NULL)
			illegal ();
	
		msgptr -> mCode = NM_UNREG_TASK;
		msgptr -> mTo = name_server_tid;
		
		Send (msgptr);
	}
}


static void delay (timeout)
long timeout;
{
	/* Delay is done by waiting for a message that will never arrive! */
	
	(void) Receive (OS_MATCH_NONE, OS_MATCH_NONE, OS_MATCH_NONE, timeout);	
}