/************************************************************************/
/*																		*/
/*		dump_line														*/
/*																		*/
/*		Richard K. Nordin			11/20/87.							*/
/*																		*/
/*		Copyright  1987-88, Apple Computer, Inc.  All rights reserved.	*/
/*																		*/
/************************************************************************/


#include <CType.h>
#include <StdIO.h>
#include <Types.h>


/*	dump_line - Dump Line
 *
 *
 */
	
void
dump_line(stream, addr, data, count)
FILE			*stream;	/* Output File Stream */
long			addr;		/* Address to Print */
unsigned char	*data;		/* Data */
int				count;		/* Number of Bytes, 0 to 16 */
{
	int				i;			/* Temporary Index */
	unsigned char	stripped;	/* Data Byte Stripped of Bit 7 */
	
	/* Print address. */
	
	fprintf(stream, "%8.8x    ", addr);
	
	/* Print hex data. */
	
	for (i = 0; i < count; i++)
	{
		switch (i%8)
		{
		case 0:
		case 2:
		case 4:
		case 6:
			fprintf(stream, "%2.2x", data[i]);
			break;
		
		case 1:
		case 3:
		case 5:
			fprintf(stream, "%2.2x ", data[i]);
			break;
		
		case 7:
			fprintf(stream, "%2.2x  ", data[i]);
			break;

		default:
			break;
		}
	}
	
	/* Print spaces. */
	
	for (i = count; i < 16; i++)
	{
		switch (i%8)
		{
		case 0:
		case 2:
		case 4:
		case 6:
			fprintf(stream, "  ");
			break;
		
		case 1:
		case 3:
		case 5:
			fprintf(stream, "   ");
			break;
		
		case 7:
			fprintf(stream, "    ");
			break;

		default:
			break;
		}
	}
	
	fprintf(stream, "  ");
	
	/* Print ASCII data. */
	
	for (i = 0; i < count; i++)
	{
		stripped = toascii(data[i]);
		fprintf(stream, "%c", isprint(stripped) ? stripped : '.');
	}
	
	fprintf(stream, "\n");
		
	return;
}
