/************************************************************************/
/*																		*/
/*			RSM_tester.c  - -  download code to NuBus card.				*/
/*																		*/
/*			Richard W. Mincher.					87/02/02.				*/
/*			Mark D. Rustad						87/06/02.				*/
/*			Philip M. Rakity					87/07/07.				*/
/*			Steve K. Wang						87/08/31.				*/
/*			Richard C. Sewill					87/12/02.				*/
/*																		*/
/*		Copyright  1987-88, Apple Computer, Inc.  All rights reserved.	*/
/*																		*/
/************************************************************************/

#include	"Stdio.h"
#include	<Files.h>
#include <Packages.h>			/*  standard file package  */
#include <Resources.h>			/*  resource file calls  */
#include	"os.h"
#include	"Download.h"
#include	"managers.h"

pascal	void	illegal ()
		extern	0x4afc;
		
/*#define	DEBUG	1*/

/*	bagit - die away with informative message.
 *
 *	entry		msg			pointer to message.
 *
 *	exit		to shell after waiting.
 */


void
bagit( msg, die)
char	*msg;
{
	fprintf(stderr,"### %s", msg);
	exit(die);
}

main(argc,argv)
int argc;
char *argv[];
{
	short		refNum;
	long		length;
	short		s, slotNum;
	char		*fileName;
	char		openName[256];
	short		initial_load;
	short		slot;
	short		selslot;
	short		status;
	short		vref;
	struct	ST_Registers registers;
	
	static char *Usage = "# Usage - %s [- SlotNum(9-E)] filename.\n";
	
	if ((status = NewFindcard(&slot, 0)) == DLE_NOERR)
	{	
		slotNum = -1;							/* Preset we have not selected any slot */
		fileName = NULL;						/* Preset we have not selected any file */
		vref = 0;								/* Preset default volume */
		selslot = 0;							/* Preset selected slots */
		initial_load = 0;						/* Preset non-initial load */
			
		for (s = 1; s < argc; s++)
		{
			length = strlen(argv[s]);
			if (*argv[s] != '-') 
			{
				fileName = argv[s];				/* Get file name */
			}
			else if (((*(argv[s]+1)) == '9' ||
				((*(argv[s]+1)) >= 'A' && (*(argv[s]+1)) <= 'E') || 	
				((*(argv[s]+1)) >= 'a' && (*(argv[s]+1)) <= 'e')) && length == 2) 	
			{
				if ((*(argv[s]+1)) == '9')
					slotNum = 9;									/* Slot 9 maps to 0 */
				else
				{
					if ((*(argv[s]+1)) >='A' && (*(argv[s]+1)) <= 'E')
						slotNum = (((*(argv[s]+1)) - 'A' + 1) & 7) + 9;	/* Upper case slot number */
					else
						slotNum = (((*(argv[s]+1)) - 'a' + 1) & 7) + 9;	/* Lower case slot number */
				}
															
				if ((slot & (1<< slotNum)) != 0)
				{
					selslot |= 1 << slotNum;		/* Select this slot */
				}
				else 								/* Send no-card-error message back to shell */
				{
					fprintf(stderr,"### %s - slot no. \"%s\" has no card.\n",argv[0],argv[s]);
					return(1);
				}
			}
			else 
			{
				fprintf(stderr,
					"### %s - slot no. \"%s\" incorrect. Slot no. must be between 9 and E.\n",
					argv[0],argv[s]);
				return(1);
			}
		}
		if (slotNum == -1)		/* If no slots are selected, select all appropriate slots */
			selslot = slot;		
			
		if (selslot == 0)
		{
			fprintf(stderr, "### %s - No cards to Download\n", argv[0]);
			return(1);
		}
	 	
		if (fileName != NULL)
		{
			/* If we have selected a file do the download */
			/* Note that slot is CHANGED by the Download subroutine */
			
			status = DLE_NOERR;
			
			strcpy(openName, fileName);
			
			c2pstr(openName);
						
			if((refNum = OpenRFPerm(openName, 0, fsRdPerm)) != -1)
			{
				for (s = 0; (s < Max_Slots) && (status == DLE_NOERR); s++)
				{
					if (selslot & 1 << s)
					{
						status = NewDownload(s, 0, 0, 0, 0, 'CODE', &registers, 0);
					}
				}
				CloseResFile(refNum);
			}
			else
			{
				fprintf(stderr, "### %s - Download file could not be opened.\n", argv[0]);
			}
		}
		else
		{
			fprintf(stderr,"### %s - No download file specified.\n", argv[0]);
			return(1);
		}
	}

	if (status == DLE_NOERR)
		exit (0);
	else if (status == DLE_NOJT)
		fprintf(stderr, "### %s - No jump table found.\n", argv[0]);
	else if (status == DLE_DATAINIT)
		fprintf(stderr, "### %s - Bad Data Init segment.\n", argv[0]);
	else if (status == DLE_GLOBALF)
		fprintf(stderr, "### %s - Global data format error.\n", argv[0]);
	else if (status == DLE_CODES)
		fprintf(stderr, "### %s - Code segment error.\n", argv[0]);
	else if (status == DLE_MAC2)
		fprintf(stderr, "### %s - Must run on a Mac II.\n", argv[0]);
	else if (status == DLE_EMPTY)
		fprintf(stderr, "### %s - No cards found.\n", argv[0]);
	else if (status == DLE_NOCARD)
		fprintf(stderr, "### %s - Slot specified is empty.\n", argv[0]);
	else if (status == DLE_RESFILE)
		fprintf(stderr, "### %s - couldn't open resource file.\n", argv[0]);
	else if (status == DLE_FILEWRONG)
		fprintf(stderr, "### %s - Download file is wrong type.\n", argv[0]);
	exit (1);
}